package com.sun.jmx.snmp.IPAcl;

import java.util.Vector;
import java.util.Enumeration;
import java.security.Principal;
import java.net.UnknownHostException;
import java.io.Serializable;
import java.security.acl.Group;

class GroupImpl extends PrincipalImpl implements Group, Serializable
{
    private static final long serialVersionUID = -7777387035032541168L;
    
    public GroupImpl() throws UnknownHostException {
    }
    
    public GroupImpl(String s) throws UnknownHostException {
        super(s);
    }
    
    public boolean addMember(Principal principal) {
        return true;
    }
    
    @Override
    public int hashCode() {
        return super.hashCode();
    }
    
    @Override
    public boolean equals(Object o) {
        return (o instanceof PrincipalImpl || o instanceof GroupImpl) && (super.hashCode() & o.hashCode()) == o.hashCode();
    }
    
    public boolean isMember(Principal principal) {
        return (principal.hashCode() & super.hashCode()) == principal.hashCode();
    }
    
    public Enumeration<? extends Principal> members() {
        Vector vector = new Vector(1);
        vector.addElement(this);
        return vector.elements();
    }
    
    public boolean removeMember(Principal principal) {
        return true;
    }
    
    @Override
    public String toString() {
        return "GroupImpl :" + super.getAddress().toString();
    }
}
